#!/usr/bin/perl

use warnings;
use strict;
use Cwd qw(abs_path);
use File::Basename;

#perl2exe_include PerlIO
#perl2exe_include Encode

#################
#### Do not edit anything above this line!
#### RemLauncher V1
#### By Glenn Hooper 2017
#### www.energy - experts.net
#### glennfhooperATgmail.com
#### GNU General Public License
#### http://www.gnu.org/licenses/.
#################

##### The file below is where we find your REMRate versions
# Its a simple text file(Use notepad) with the following.(Version=FilePath\exe)
# EXAMPLE LINE below
# 12.97=C:\Users\Public\Architectural Energy Corporation\REM Rate 12-97\REMRate12.exe\
#####

my $remvrtxt = 'remdir.txt';

##DO NOT EDIT BELOW THIS LINE
###############################

my $debug = ''
  ; # prints out many steps, including option to launch or not at end of script.

#my $remvrtxt = ''; 			# Uncomment this for debug, AND set line 42 and 43 correctly..

my $path;
my $arg0;
my $line;
my $remvr;
my $ver;
my $script = "$0";

if ($remvrtxt) {
    $path = abs_path($0);

# C:\Users\Public\Architectural Energy Corporation\RemLaunch ad to path with
# comman line arg of C:\Users\Glenn\ownCloud\Ratings\Fallon\0030-0262-P1_TBD_13 Nereid Place_CODE_HERS.blg
# change back slash to forward (back slashes are special in perl)
    $path =~ tr|\\|/|;    #change back to forward
    if ( $path =~ m|(.*)(remlaunch.pl)$| ) {
        $path = $1;

        if ($debug) { print "Rem version txt file located at $path \n"; }
    }
    $remvr = "$path$remvrtxt";
    $arg0  = "$ARGV[0]";

    if ($debug) { print "REM file trying to be opened is at \n$arg0 \n"; }

}
else {    #for local debug set 2 vars as script would have by now
    $remvr =
      'C:/Users/Public/Architectural Energy Corporation/RemLaunch/remdir.txt'
      ;    #My debug filler
    $arg0 =
'C:\Users\Glenn\ownCloud\Ratings\Fallon\0030-0262-P1_TBD_13 Nereid Place_CODE_HERS.blg'
      ;    #My debug filler
}

$arg0 =~ s/\\/\//g
  ; #Change back slashes to forward in rem file path (back slashes are special in perl)
my $fname = "$arg0"
  ;  #Left this as a reminder, $fname  IS the argument being sent to this script

if ($debug) { print "Rem file path fixed to forward slashes to $fname \n"; }

open( my $fh, '<:encoding(UTF-8)', $fname )
  or die("Can't open REMRate file \"$fname\":$!\n");
my @lines = <$fh>;

close($fh);

if ($debug) { print "Rem file line 3 or \$lines[2] =$lines[2] \n"; }

$line = $lines[2];

if ($debug) { print "Rem file \$line =$line \n"; }

chomp($line);         #removed newline
$line =~ s/\s+$//;    #removed empty space from end of line

if ( $line =~ /(\S+)$/ )
{ #capture only the right most digits untill whitspace. a typical 3rd line looks like "1 7 14.6.1" we need only "14.6.1"
    $ver = "$1";    #regular exp above and set $ver to the $1
    if ($debug) { print "Rem ver found \$ver set to =$ver \n"; }
}

if ($debug) { print "Rem file version is =$ver \n"; }
open( my $remvrfh, '<:encoding(UTF-8)', $remvr )
  or die("Can't open input rem version file \"$remvr\":$!\n");
close($remvr);
while ( my $vrline = <$remvrfh> ) {
    chomp($vrline);
    ( my $word1, my $word2 ) = split /=/,
      $vrline; #word1 is the version in our lookup text file #word 2 is the path

    if ( $word1 eq $ver ) {
        $word2 =~ s/\\/\//g
          ; #we found a match, so change back slashes to forward in the needed exe path

        if ($debug) { print "Found in lookup $word1=$word2  \n"; }

        $word2 =~ tr{/}{\\};  #changed to back slashes to keep windows exe happy
        $fname =~ tr{/}{\\};  #changed to back slashes to keep windows exe happy
        my $mylaunch = "START \"\" \"$word2\" \"$fname\"";

        if ($debug) {
            print "$mylaunch \n";
            print "Shall we launch REMRate? \n";
            chomp( my $choice = <STDIN> );

            if ( $choice eq "n|no" ) { exit; }
        }
        {                     #curleys allow warning free launch
            exec("$mylaunch");
        }
        last;

    }
}

